#include <sourcemod>
#include <sdktools>
#include <cstrike> 
#include <knife_arena> 

#pragma semicolon 1

#define PLUGIN_VERSION 	"1.0"
#define PLUGIN_AUTHOR	"tuty"

#define SOUND_FILE	"misc/medic.wav"

new Handle:gPluginEnabled = INVALID_HANDLE;
new Handle:gHealthAmount = INVALID_HANDLE;
new Handle:gMinHealth = INVALID_HANDLE;
new Handle:gMedicCost = INVALID_HANDLE;
new Handle:gShowInChat = INVALID_HANDLE;
new Handle:gMaxTimeUse = INVALID_HANDLE;

new gPlayerMoney;
new gUsedMedic[MAXPLAYERS+1];


public Plugin:myinfo = 
{
	name = "CSS Medic",
	author = "Music",
	description = "",
	version = "5.1",
	url = ""
};
public OnPluginStart()
{
	HookEvent( "round_start", Event_RoundStart );
	
	RegConsoleCmd( "say", Command_Medic );
	RegConsoleCmd( "say_team", Command_Medic );

	CreateConVar( "cssmedic_version", PLUGIN_VERSION, "CSS Medic Version", FCVAR_PLUGIN | FCVAR_SPONLY | FCVAR_REPLICATED | FCVAR_NOTIFY );

	gPluginEnabled = CreateConVar( "css_medic", "1" );
	gMinHealth = CreateConVar( "css_medic_minhealth", "40" );
	gHealthAmount = CreateConVar( "css_medic_healhealth", "100" );
	gMedicCost = CreateConVar( "css_medic_cost", "2000" );
	gShowInChat = CreateConVar( "css_medic_showcall", "1" );
	gMaxTimeUse = CreateConVar( "css_medic_maxuse", "1" );
	
	AutoExecConfig(true);
	
	gPlayerMoney = FindSendPropOffs( "CCSPlayer", "m_iAccount" );
}
public OnClientConnected( id )
{
	gUsedMedic[ id ] = 0;
}
public OnClientDisconnect( id )
{
	gUsedMedic[ id ] = 0;
}
public OnMapStart()
{
	decl String:MedicSound[ 100 ];
	FormatEx( MedicSound, sizeof( MedicSound ) - 1, "sound/%s", SOUND_FILE );
	
	if( FileExists( MedicSound )  )
	{
		AddFileToDownloadsTable( MedicSound );
		PrecacheSound( SOUND_FILE, true );
	}
}

public Event_RoundStart( Handle:event, const String:name[], bool:dontBroadcast )
{
	for(new i = 1; i <= MaxClients; ++i)
	{
		gUsedMedic[ i ] = 0;
	}
}

public Action:Command_Medic( id, args )
{
	if (id < 1 || id > MaxClients || KA_ClientOnArena(id)) return Plugin_Continue;
	decl String:Said[ 128 ];

	GetCmdArgString( Said, sizeof( Said ) - 1 );
	StripQuotes( Said );
	TrimString( Said );
	
	if( StrEqual( Said, "!medic" ) || StrEqual( Said, "!medsestra" ) || StrEqual( Said, "мед" ) || StrEqual( Said, "сестра" ) || StrEqual( Said, "медсестра" ) || StrEqual( Said, "!med" ) )
	{
		if( GetConVarInt( gPluginEnabled ) == 0 )
		{
			PrintToChat( id, "\x07FF00FFТы не можешь вызвать медсестру, пока ты мертв или не в команде!" );
			
			return Plugin_Continue;
		}
			
		if( !IsPlayerAlive( id ) )
		{
			PrintToChat( id, "\x0700FF00Ты не можешь вызвать медсестру, \x07FF0040пока ты мертв!" );
		
			return Plugin_Continue;
		}

		new maxtime = GetConVarInt( gMaxTimeUse );

		if( gUsedMedic[ id ] >= maxtime )
		{
			PrintToChat( id, "\x07FF0040Медсестру можно вызвать только \x07FFFFFF%d \x07FF0040раз за раунд!", maxtime );
			
			return Plugin_Continue;
		}
		
		new money = GetClientMoney( id );
		new cost = GetConVarInt( gMedicCost );
		
		if( money < cost )
		{
			PrintToChat( id, "\x07FF8000У тебя недостаточно денег для вызова медсестры! \x0700FF00Она стоит \x07000000%d$", cost );
			
			return Plugin_Continue;
		}
		
		if( GetClientHealth( id ) >= GetConVarInt( gMinHealth ) )
		{
			PrintToChat( id, "\x07FF0040У Тебя достаточно здоровья \x0700FF00медсестра тебе не нужна" );
			
			return Plugin_Continue;
		}
		
		gUsedMedic[ id ]++;

		SetEntProp( id, Prop_Data, "m_iHealth", GetConVarInt( gHealthAmount ) );
		SetClientMoney( id, money - cost );
		PrintToChat( id, "\x07FF0040Ты успешно вызвал медсестру! \x0700FF00Теперь ты удовлетворён" );
	
		if( GetConVarInt( gShowInChat ) != 0 )
		{
			decl String:Name[ 32 ];
			GetClientName( id, Name, sizeof( Name ) - 1 );

//			PrintToChatAll( "\x0700FF00%s \x078000FFвызвал \x03Медика", Name );
		}
		
		new Float:fOrigin[ 3 ];
		GetClientAbsOrigin( id, Float:fOrigin );
		
		EmitAmbientSound( SOUND_FILE, fOrigin, id, SNDLEVEL_CONVO );
		AttachClientIcon( id );
	}
	
	return Plugin_Continue;
}	
stock SetClientMoney( index, money )
{
	if( gPlayerMoney != -1 )
	{
		SetEntData( index, gPlayerMoney, money );
	}
}
stock GetClientMoney( index )
{
	if( gPlayerMoney != -1 )
	{
		return GetEntData( index, gPlayerMoney );
	}
	
	return 0;
}
stock AttachClientIcon( index )
{
	TE_Start( "RadioIcon" );
	TE_WriteNum( "m_iAttachToClient", index );
	TE_SendToAll();
}
